declare namespace openfl.text {
	
	/**
	 * The TextFormatAlign class provides values for text alignment in the
	 * TextFormat class.
	 */
	export enum TextFormatAlign {
		
		/**
		 * Constant; centers the text in the text field. Use the syntax
		 * `TextFormatAlign.CENTER`.
		 */
		CENTER = "center",
		
		END = "end",
		
		/**
		 * Constant; justifies text within the text field. Use the syntax
		 * `TextFormatAlign.JUSTIFY`.
		 */
		JUSTIFY = "justify",
		
		/**
		 * Constant; aligns text to the left within the text field. Use the syntax
		 * `TextFormatAlign.LEFT`.
		 */
		LEFT = "left",
		
		/**
		 * Constant; aligns text to the right within the text field. Use the syntax
		 * `TextFormatAlign.RIGHT`.
		 */
		RIGHT = "right",
		
		START = "start"
		
	}
	
}


export default openfl.text.TextFormatAlign;